
#ifndef _EDW_WS2812_H_
#define	_EDW_WS2812_H_


#include <Arduino.h>



#define WS2812_BASE_I2C     0x30
//
#define  WS2812_CFG_NODISPLAY  0x08     // Bajt konfiguracji: 0-wyswietl otrzymane dane, 1-nie wyswietlaj
#define  WS2812_CFG_GAMMA   0x10     // Bajt konfiguracji: gamma 0-off, 1-on
#define  WS2812_CFG_COLOR_MSK  0b01100000     // Kolor maska
#define  WS2812_CFG_COLOR_24   0b00000000     // Kolor 24-bit
#define  WS2812_CFG_COLOR_16   0b00100000     // Kolor 16-bit - R5 G6 B5
#define  WS2812_CFG_COLOR_8    0b01000000     // Kolor 8-bit - R3 G3 B2
#define  WS2812_CFG_COLOR_218  0b01100000     // 218 bezpiecznych barw
//
#define  WS2812_BRIGHT_MSK    0b11111000   // Maska jasnosci barw (rejest Adr_H)
//
#define WS2812_CMD_SCR          0     // Dane dotycza pamieci ekranu
#define WS2812_CMD_COLOR_TAB    1     // Dane dotycza tablicy kolorow


class EdWws2812  {
  public:
    EdWws2812( int liczbaLed, byte cfg, byte csPin, uint32_t spd );

    byte* begin();
    void setLed( int nrDiody, byte r, byte g, byte b );
    void show( byte bright );
    void clr();
    byte EdWws2812_st, EdWws2812_i2c, EdWws2812_Err, EdWws2812_paleta;
    byte TWI_Status;
    uint16_t EdWws2812_Ram; // Zapotrzebowanie na RAM


  private:
    byte EdWws2812::TWI_Action( byte command );
    byte EdWws2812::TWI_Stop();
    byte EdWws2812::TWI_StatusTransceiver_Busy();
    byte EdWws2812::TWI_Start();
    byte EdWws2812::TWI_Read( byte ack );
    byte EdWws2812::TWI_Write( byte d );
    void EdWws2812::TWI_Master_Initialise( uint32_t speed );
    void EdWws2812::SPI_Send8MHz( byte dane );

    byte csPin_;
    byte cfg_;
    int liczbaLed_;
    byte *pixels_;
    uint32_t speed_;
    byte adrI2c_;
    byte paleta_;
};


#endif
